map = {}
map_mt = {__index = map}

function map:new(mapfile, tset)
local o = {}
o.header = {}
o.data = {}
o.objects = {}
local f = love.filesystem.read(mapfile)

local a = 0
local b = 0
a = string.find(f, 'width="') + 7
b = string.find(f, '"', a) - 1
o.header.width = tonumber(string.sub(f, a, b))

a = string.find(f, 'height="') + 8
b = string.find(f, '"', a) - 1
o.header.height = tonumber(string.sub(f, a, b))

local lyrs = 0
a,b = 0,0
while (string.find(f, "<layer", a) ~= nil) do
	lyrs = lyrs + 1
	a = string.find(f, "<layer", a) + 1
end
o.header.layers = lyrs

local lyrstrt = {}
a,b = 0,0
for i=1,o.header.layers do
	 lyrstrt[i] = f:find('<data encoding="csv">', a+1) + 21
	 a = lyrstrt[i]
end
a,b = 0,0

for l=1,o.header.layers do
	a,b = lyrstrt[l],lyrstrt[l]
	o.data[l] = {}
	for h=1,o.header.height do
		a = a+1
		o.data[l][h] = {}
		for w=1,o.header.width do
			if w ~= o.header.width or h ~= o.header.height then
				b = f:find(',', a+1)-1
			else
				b = f:find('\n', a+1)-1
			end
			o.data[l][h][w] = tonumber(string.sub(f, a, b))
			a = b+2
		end
	end
end

a,b = 0,0
a = f:find("<objectgroup")
local i = 1
while(f:find("<object", a+1) ~= nil) do
	o.objects[i] = {}
	a = f:find("x=", a)+3
	b = f:find('"', a)-1
	o.objects[i].x = tonumber(f:sub(a, b))
	a = f:find("y=", a)+3
	b = f:find('"', a)-1
	o.objects[i].y = tonumber(f:sub(a, b))
	a = f:find("width=", a)+7
	b = f:find('"', a)-1
	o.objects[i].w = tonumber(f:sub(a, b))
	a = f:find("height=", a)+8
	b = f:find('"', a)-1
	o.objects[i].h = tonumber(f:sub(a, b))
	i = i+1
end

o.header.screentw = math.ceil(love.graphics.getWidth()/(constants.base * constants.scale))+1
o.header.screenth = math.ceil(love.graphics.getHeight()/(constants.base * constants.scale))+1
o.header.tileset = tset
for l=1,o.header.layers do
	o.data[l].sb = love.graphics.newSpriteBatch(tset.img, o.header.screentw*o.header.screenth)
end
setmetatable(o, map_mt)
return o

end

function map:update(dt, camera)
if (camera.oldx ~= camera.x) or (camera.oldy ~= camera.y) then
local unit = constants.base*constants.scale
for layer=1,self.header.layers do
	self.data[layer].sb:clear()
	local c = {}
	c.tx = math.floor(camera.x/unit)
	c.ty = math.floor(camera.y/unit)
	c.ox = math.floor(camera.x%unit)
	c.oy = math.floor(camera.y%unit)
	for a=1,self.header.screenth do
		for b=1,self.header.screentw do
			if self.data[layer][a+(c.ty-5)] then
				if self.header.tileset[self.data[layer][a+(c.ty-5)][b+(c.tx-6)]] then
				self.data[layer].sb:addq(self.header.tileset[self.data[layer][a+(c.ty-5)][b+(c.tx-6)]], ((b-1)*unit)-c.ox, ((a-1)*unit)-c.oy, 0, constants.scale, constants.scale)
				end
			end
		end
	end
end
camera.oldx = camera.x
camera.oldy = camera.y
end
end

function map:draw(layer)
love.graphics.draw(self.data[layer].sb, 0, 0)
love.graphics.print("\n\n\n\n" .. self.header.screenth .. "\n" .. self.header.screentw, 20, 20)
end

function getTileSet(file, tilesize)
local i = love.graphics.newImage(file)
i:setFilter("nearest", "nearest")
local th = i:getHeight()/tilesize
local tw = i:getWidth()/tilesize
local tiles = {}
tiles.img = i
tiles.size = tilesize
for a=1,th do
	for b=1,tw do
		tiles[(tw*(a-1))+b] = love.graphics.newQuad(tilesize*(b-1), tilesize*(a-1), tilesize, tilesize, i:getWidth(), i:getHeight())
	end
end
return tiles

end
















